function [M,bhat,rss,bic,MM,best,sse] = NISnng_perm(y,x,fx,quant,N,method,weight,tol)

[n,p] = size(x);
if nargin < 4
    quant = 1; N = ceil(p/4); method = 'AIC'; weight = ones(size(y)); tol = 1e-4;
elseif nargin < 5
    N = ceil(p/4); method = 'AIC'; weight = ones(size(y)); tol = 1e-4;
elseif nargin < 6
    method = 'AIC'; weight = ones(size(y)); tol = 1e-4;
elseif nargin < 7
    weight = ones(size(y)); tol = 1e-4;
elseif nargin <8
    tol = 1e-4;
end

if N > p
    fprintf(1,'Too many iterations! Reset to the number of variables.\n');
    N = p;
end

kk = 1;
MM = {}; Mact = [];
best = {}; sse = []; bic = [];
while kk <= N
    
    M1 = screen_perm(y,x,Mact,quant,fx,weight);
    [M2,bhat2,sse2] = nngiter(y,x,M1,fx,weight,tol);
    
    if isempty(setxor(Mact,M2)) || isempty(M2)
        break;
    end
    
    best{kk} = bhat2;
    sse(kk) = sse2;
    if strcmp(method,'AIC') == 1
        bic(kk) = log(sse2)+length(bhat2)*2/n;
    else
        bic(kk) = log(sse2)+length(bhat2)*log(n)/n;
    end
    MM{kk} = M2; Mact = M2; kk = kk+1;
end

kk1 = find(bic==min(bic));
if length(kk1) > 1
    kk1 = kk1(sse(kk1)==min(sse(kk1)));
    if length(kk1) > 1
        kk1 = kk1(1);
    end
end

M = MM{kk1};
rss = sse(kk1);
bhat = best{kk1};
            

