function [Mnlin,Mlin,bhat,rss,bic,M1,M2,best,sse] = mixNISnng(y,x,fx,d,N,tol)

n = size(x,1);
if nargin < 4
    d = 1; N = 15; tol = 1e-3;
elseif nargin < 5
    N = 15; tol = 1e-3;
elseif nargin < 6
    tol = 1e-3;
end
 
kk = 1;
M1 = {}; M2 = {};  Mnlin0 = []; Mlin0 = [];
best = {}; sse = []; bic = [];
while kk < N
    
    % marginal fitting
    [Mnlin1,Mlin1] = mixscreen(y,x,Mnlin0,Mlin0,d,fx);
    
    % iterative algorithm for NNG
    [bb,Mnlin1,Mlin1,ss] = mixnngiter(y,x,Mnlin1,Mlin1,fx,tol);
    if isempty(setxor(Mnlin1,Mnlin0)) && isempty(setxor(Mlin1,Mlin0))   
        break;
    end
    
    best{kk} = bb;
    sse(kk) = ss;
    bic(kk) = log(ss)+length(bb)*log(n)/n;
    M1{kk} = Mnlin1; M2{kk} = Mlin1; 
    Mnlin0 = Mnlin1; Mlin0 = Mlin1;
    kk = kk+1;

end

kk1 = find(bic==min(bic));
Mnlin = M1{kk1};
Mlin = M2{kk1};
bhat = best{kk1};
rss = sse(kk1);

            

