function [Mnlin,Mlin,snlin,slin,bnlin,blin] = mixscreen(y,x,Mnlin,Mlin,d,fx)
% y: n*1
% x: n*p
% Mact: index of active genes
% d: number of covariates selected

hf = @(bb,xx,qq) [fx(bb(1:qq),xx(:,1:qq)),xx(:,qq+1:end)]*bb(qq+1:end)';

p = size(x,2);
Mact = sort(union(Mnlin,Mlin));
q = length(Mnlin); pact = length(Mact);

xnlin = x(:,Mnlin); xlin = x(:,Mlin);
Mcan = setdiff(1:p,Mact);
xcan = x(:,Mcan);

blin = zeros(p-pact,pact+q+1);
slin = zeros(1,p-pact);
bnlin = zeros(p-pact,pact+q+2);
snlin = zeros(1,p-pact);

if q == 0
    parfor i = 1:(p-pact)
        [blintmp,~,rlin] = regress(y,[xlin,xcan(:,i)]);
        blin(i,:) = blintmp';
        slin(i) = norm(rlin);
        
        hfmin = @(bb) norm(hf(bb,[xcan(:,i),xlin],1)-y);
        [bnlin(i,:),snlin(i)] = ga(hfmin,2+pact,[],[],[],[],...
            0.01*ones(1,2+pact),7*ones(1,2+pact));
        [bnlintmp,snlintmp] = fmincon(hfmin,bnlin(i,:),[],[],[],[],...
            0.01*ones(1,2+pact),7*ones(1,2+pact),[],...
            optimset('Algorithm','sqp','MaxFunEvals',1000,'MaxIter',1000));
        if snlin(i) > snlintmp
            snlin(i) = snlintmp;
            bnlin(i,:) = bnlintmp;
        end
    end
else
    parfor i = 1:(p-pact)
        hfmin = @(bb) norm(hf(bb,[xnlin,xlin,xcan(:,i)],q)-y);
        [blin(i,:),slin(i)] = ga(hfmin,pact+q+1,[],[],[],[],...
            0.01*ones(1,pact+q+1),7*ones(1,pact+q+1));
        [blintmp,slintmp] = fmincon(hfmin,blin(i,:),[],[],[],[],...
            0.01*ones(1,pact+q+1),7*ones(1,pact+q+1),[],...
            optimset('Algorithm','sqp','MaxFunEvals',1000,'MaxIter',1000));
        if slin(i) > slintmp
            slin(i) = slintmp;
            blin(i,:) = blintmp;
        end
        
        hfmin = @(bb) norm(hf(bb,[xcan(:,i),xnlin,xlin],q+1)-y);
        [bnlin(i,:),snlin(i)] = ga(hfmin,pact+q+2,[],[],[],[],...
            0.01*ones(1,pact+q+2),7*ones(1,pact+q+2));
        [bnlintmp,snlintmp] = fmincon(hfmin,bnlin(i,:),[],[],[],[],...
            0.01*ones(1,pact+q+2),7*ones(1,pact+q+2),[],...
            optimset('Algorithm','sqp','MaxFunEvals',1000,'MaxIter',1000));
        if snlin(i) > snlintmp
            snlin(i) = snlintmp;
            bnlin(i,:) = bnlintmp;
        end
    end
end

ss = min([snlin;slin]);
[~,id] = sort(ss);
if d == 1 && isempty(Mact)
    Mnlin = sort(id(1:2));
    Mlin = Mnlin;
else
    Mnlin = sort([Mnlin,Mcan(id(1:d))]);
    Mlin = sort([Mlin,Mcan(id(1:d))]);
end




