function [M,bhat,rss] = nngiter(y,x,Mact,fx,weight,tol)
% y: n x 1
% x: n x p
% Mact: index of active genes
% fx: function handel
% tol: tolerence

if nargin < 5
    weight=ones(size(y)); tol = 1e-3;
elseif nargin < 6
    tol = 1e-4;
end
hf = @(bb,xx) fx(bb(1+size(xx,2):end),xx)*bb(1:size(xx,2))';

if length(Mact) == 1
%     hfmin = @(bb) mean(weight.*(hf(bb,x(:,Mact))-y).^2);
    hfmin = @(bb) norm(sqrt(weight).*(hf(bb,x(:,Mact))-y));
%     [bhat,rss] = ga(hfmin,2,[0,-1],0,[],[],[],[],[],gaoptimset('Generations',1000,'Display','off'));
%     [bhattmp,rsstmp] = fmincon(hfmin,bhat,[0,-1],0,[],[],[],[],[],...
%         optimset('Algorithm','sqp','MaxFunEvals',1000,'MaxIter',1000,'Display','off'));
    [bhat,rss] = ga(hfmin,2,[],[],[],[],ones(1,2),5*ones(1,2),[],...
        gaoptimset('Generations',1000,'Display','off'));
    [bhattmp,rsstmp] = fmincon(hfmin,bhat,[],[],[],[],ones(1,2),5*ones(1,2),[],...
        optimset('Algorithm','sqp','MaxFunEvals',1000,'MaxIter',1000,'Display','off'));
    if rss > rsstmp
        bhat = bhattmp;
%         rss = rsstmp;
    end
    rss = mean((hf(bhat,x(:,Mact))-y).^2);
    M = Mact;
    return;
end

step = 0;
while step == 0
%     hfmin = @(bb) mean(weight.*(hf(bb,x(:,Mact))-y).^2);
    hfmin = @(bb) norm(sqrt(weight).*(hf(bb,x(:,Mact))-y));
    pact = length(Mact);
    A = [zeros(pact),-eye(pact)];
    [b0,s0] = ga(hfmin,2*pact,A,zeros(pact,1),[],[],[],[],[],...
        gaoptimset('Generations',1000,'Display','off'));
    [b0tmp,s0tmp] = fmincon(hfmin,b0,A,zeros(pact,1),[],[],[],[],[],...
        optimset('Algorithm','sqp','MaxFunEvals',1000,'MaxIter',1000,'Display','off'));
%     [b0,s0] = ga(hfmin,2*pact,[],[],[],[],0.01*ones(1,2*pact),5*ones(1,2*pact),[],...
%         gaoptimset('Generations',1000,'Display','off'));
%     [b0tmp,s0tmp] = fmincon(hfmin,b0,[],[],[],[],0.01*ones(1,2*pact),5*ones(1,2*pact),[],...
%         optimset('Algorithm','sqp','MaxFunEvals',1000,'MaxIter',1000,'Display','off'));
    if s0 > s0tmp
        b0 = b0tmp; 
        s0 = s0tmp;
    end
%     s0 = mean((hf(b0,x(:,Mact))-y).^2);
    
    b0 = reshape(b0,pact,2)';
    id0 = Mact(abs(b0(1,:))>tol & abs(b0(2,:)>tol));
    if length(id0) == pact
        step = 1;
    elseif ~isempty(id0)
        Mact = id0;
    end
end


n = length(y);
ystd = (y-mean(y))/std(y).*sqrt(weight);
ssu = s0; ssc = 0; bc = b0;
while abs(ssc-ssu) > tol
    
    ssc = ssu;
    
    z = fx(bc(2,:)',x(:,Mact));
    zstd = diag(sqrt(weight))*(z-repmat(mean(z),n,1))*diag(1./std(z));
    beta0 = nng_finds(zstd,ystd,{'Method','kcv','stderror'})';
%     beta0 = nngone(zstd,ystd)';
    id1 = (abs(beta0)>tol);
    M1 = Mact(id1);
    if isempty(M1)
        M=[]; bhat = []; rss = [];
        return;
    end
    
    p1 = length(M1);
    beta1 = beta0(id1)*std(y)./std(z(:,id1));
%     hfmin = @(bb) mean(weight.*(fx(bb,x(:,M1))*beta1'-y).^2);
    hfmin = @(bb) norm(sqrt(weight).*(fx(bb,x(:,M1))*beta1'-y));
    [b1,ssu] = fmincon(hfmin,bc(2,id1),-eye(p1),zeros(p1,1),[],[],[],...
        [],[],optimset('Algorithm','sqp','MaxFunEvals',1000,'MaxIter',1000,'Display','off'));
%     [b1,ssu] = fmincon(hfmin,bc(2,id1),[],[],[],[],ones(1,p1),5*ones(1,p1),...
%         [],optimset('Algorithm','sqp','MaxFunEvals',1000,'MaxIter',1000,'Display','off'));
%     hfmin = @(bb) mean(weight.*(hf(bb,x(:,M1))-y).^2);
%     A = [zeros(p1),-eye(p1)];
%     b1 = fmincon(hfmin,[beta1,bc(2,id1)],A,zeros(p1,1),[],[],[],[],...
%         [],optimset('Algorithm','sqp','MaxFunEvals',1000,'MaxIter',1000,'Display','off'));
%     b1 = reshape(b1,p1,2)';
%     id2 = (abs(b1(1,:))>tol & abs(b1(2,:))>tol);
    id2 = (abs(b1)>tol);
    M2 = M1(id2);
    if isempty(M2)
        M =[]; bhat = []; rss = [];
        return;
    end
%     bc = b1(:,id2);
    bc = [beta1(id2);b1(id2)];
%     ssu = mean((hf(bc,x(:,M2))-y).^2);
    if isempty(setxor(Mact,M2))
        break;
    end
    Mact = M2;
end

bc = [bc(1,:),bc(2,:)]; M = Mact;
hfmin = @(bb) mean(weight.*(hf(bb,x(:,M))-y).^2);
p = length(M);
% A = [zeros(p),-eye(p)];
% bhat = fmincon(hfmin,bc,A,zeros(p,1),[],[],[],[],[],...
%     optimset('Algorithm','sqp','MaxFunEvals',1000,'MaxIter',1000,'Display','off'));
bhat = fmincon(hfmin,bc,[],[],[],[],ones(1,2*p),5*ones(1,2*p),[],...
    optimset('Algorithm','sqp','MaxFunEvals',1000,'MaxIter',1000,'Display','off'));
rss = mean((hf(bhat,x(:,M))-y).^2);

