function [M,rss,bhat] = screen_perm(y,x,Mact,quant,fx,weight)
% y: n*1
% x: n*p
% Mact: index of active genes
% d: number of covariates selected

if nargin < 6
    weight = ones(size(y));
end
hf = @(bb,xx) fx(bb(1+size(xx,2):end),xx)*bb(1:size(xx,2))';

[n,p] = size(x);
Mact = sort(Mact);
xact = x(:,Mact);
ind = setdiff(1:p,Mact);
xcan = x(:,ind);
pact = length(Mact);
bhat = zeros(p-pact,2*pact+2);
rss = zeros(1,p-pact);

parfor i = 1:(p-pact)
    
    hfmin = @(bb) mean(weight.*(hf(bb,[xact,xcan(:,i)])-y).^2);
%     hfmin = @(bb) norm(sqrt(weight).*(hf(bb,[xact,xcan(:,i)])-y));
    A = [zeros(pact+1),-eye(pact+1)];
    [bhat(i,:),rss(i)] = ga(hfmin,2*pact+2,A,zeros(pact+1,1),[],[],[],[],[],...
        gaoptimset('Generations',1000,'Display','off'));
    [bhat1,rss1] = fmincon(hfmin,bhat(i,:),A,zeros(pact+1,1),[],[],[],[],[],...
        optimset('Algorithm','sqp','MaxFunEvals',1000,'MaxIter',1000,'Display','off'));
%     [bhat(i,:),rss(i)] = ga(hfmin,2*pact+2,[],[],[],[],0.01*ones(1,2*pact+2),...
%         5*ones(1,2*pact+2),[],gaoptimset('Generations',1000,'Display','off'));
%     [bhat1,rss1] = fmincon(hfmin,bhat(i,:),[],[],[],[],0.01*ones(1,2*pact+2),...
%         5*ones(1,2*pact+2),[],optimset('Algorithm','sqp','MaxFunEvals',1000,'MaxIter',1000,'Display','off'));
    if rss(i) > rss1
        bhat(i,:) = bhat1;
        rss(i) = rss1;
    end
    
end

mindex = randperm(n);
mrss = zeros(1,p-pact);
parfor i = 1:(p-pact)
    
    hfmin = @(bb) mean(weight.*(hf(bb,[xact,xcan(mindex,i)])-y).^2);
%     hfmin = @(bb) norm(sqrt(weight).*(hf(bb,[xact,xcan(:,i)])-y));
    A = [zeros(pact+1),-eye(pact+1)];
    [mbhat,mrss(i)] = ga(hfmin,2*pact+2,A,zeros(pact+1,1),[],[],[],[],[],...
        gaoptimset('Generations',1000,'Display','off'));
    [~,mrss1] = fmincon(hfmin,mbhat,A,zeros(pact+1,1),[],[],[],[],[],...
        optimset('Algorithm','sqp','MaxFunEvals',1000,'MaxIter',1000,'Display','off'));
%     [bhat(i,:),rss(i)] = ga(hfmin,2*pact+2,[],[],[],[],0.01*ones(1,2*pact+2),...
%         5*ones(1,2*pact+2),[],gaoptimset('Generations',1000,'Display','off'));
%     [bhat1,rss1] = fmincon(hfmin,bhat(i,:),[],[],[],[],0.01*ones(1,2*pact+2),...
%         5*ones(1,2*pact+2),[],optimset('Algorithm','sqp','MaxFunEvals',1000,'MaxIter',1000,'Display','off'));
    if mrss(i) > mrss1
        mrss(i) = mrss1;
    end
    
end

res_thres = quantile(mrss,1-quant);
if(isempty(Mact))
    newind = max(min(sum(rss<res_thres),floor(n/10)),2);
else
    newind = min(sum(rss<res_thres),floor(n/5)-length(Mact));
end

[~,idx] = sort(rss);
M = sort([Mact,ind(idx(1:newind))]);

